using JiShe.CollectBus.Common.Extensions;
using JiShe.CollectBus.Protocol.Dto;
using JiShe.CollectBus.Protocol.Interfaces;
using JiShe.CollectBus.Protocol3761;
using Microsoft.Extensions.Logging;

namespace GatherService.WattMeter.AnalysisData.AFN_10H
{
    /// <summary>
    /// 5.16.1.2.1 F1：透明转发 读取SIM卡信息
    /// </summary>
    public class AFN16_F101_Analysis : IAnalysisStrategy<TB3761>
    {
        private readonly ILogger<AFN16_F101_Analysis> _logger;

        public AFN16_F101_Analysis(ILogger<AFN16_F101_Analysis> logger)
        {
            _logger = logger;
        }

        public Task<bool> ExecuteAsync(TB3761 input, Action<dynamic>? result = null)
        {
            try
            {
                ArgumentNullException.ThrowIfNull(input);
                ArgumentNullException.ThrowIfNull(input.UnitData.HexMessageList);
                UnitDataAnalysis<string> dto = new UnitDataAnalysis<string>
                {
                    Code = input.A.Code!,
                    AFN = input.AFN_FC.AFN,
                    Fn = input.DT.Fn,
                    Pn = input.DA.Pn,
                    Data = AnalysisDataUnit(input.UnitData.HexMessageList), //SIM卡
                    HexMessage = input.BaseHexMessage.HexMessageString,
                    MessageId = input.MessageId,
                    ReceivedTime = input.ReceivedTime
                };
                result?.Invoke(dto);
                return Task.FromResult(true);
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, $"10_101解析失败:{input.A?.Code}-{input.DT?.Fn ?? 0}-{input?.BaseHexMessage?.HexMessageString},{ex.Message}");

            }
            return Task.FromResult(false);
        }
        private string AnalysisDataUnit(List<string> hexMessageList)
        {
            //TODO:转发内容
            var dataArray = hexMessageList.Skip(18).ToList();
            var contentLengthArr = dataArray.Skip(1).Take(2).ToList();
            contentLengthArr.Reverse();
            int contentLength = string.Join("", contentLengthArr).HexToDec();
            var dataField = dataArray.Skip(3).Take(contentLength).ToList();
            var sim = string.Join("", dataField).TrimStart('0');
            return sim.Length != 20 ? "" : sim;
        }
    }
}
